"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var styles_1 = __importDefault(require("./styles"));
exports.MENU_OPEN_DURATION = 150;
var FloatingMenu = /** @class */ (function (_super) {
    __extends(FloatingMenu, _super);
    function FloatingMenu() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { optionsContainerAnim: new react_native_1.Animated.Value(0), isMenuOpen: false };
        /**
         * Toggle the visibility of the collapsible menu.
         */
        _this.toggleMenu = function () {
            var _a = _this.state, optionsContainerAnim = _a.optionsContainerAnim, isMenuOpen = _a.isMenuOpen;
            react_native_1.Animated.timing(optionsContainerAnim, {
                toValue: isMenuOpen ? 0 : 210,
                easing: react_native_1.Easing.cubic,
                duration: exports.MENU_OPEN_DURATION,
            }).start(function () { return _this.setState({ isMenuOpen: !isMenuOpen }); });
        };
        _this.onSelectOption = function (option) {
            var _a = _this.props, onSelectItem = _a.onSelectItem, closeOnSelect = _a.closeOnSelect;
            if (closeOnSelect)
                _this.toggleMenu();
            onSelectItem(option);
        };
        return _this;
    }
    Object.defineProperty(FloatingMenu.prototype, "isOpen", {
        /**
         * Indicates whether the collapsible menu is currently visible.
         */
        get: function () {
            return this.state.isMenuOpen;
        },
        enumerable: true,
        configurable: true
    });
    FloatingMenu.prototype.render = function () {
        var _this = this;
        var _a = this.props, items = _a.items, selectedItem = _a.selectedItem, showSelectedIndicator = _a.showSelectedIndicator;
        var _b = this.state, optionsContainerAnim = _b.optionsContainerAnim, isMenuOpen = _b.isMenuOpen;
        return (<react_native_1.View style={styles_1.default.wrapper}>
        <react_native_1.Animated.View style={[
            styles_1.default.optionsContainer,
            { height: optionsContainerAnim, marginBottom: isMenuOpen ? -4 : 0 },
        ]}>
          <react_native_1.ScrollView contentContainerStyle={[styles_1.default.scrollContainer]}>
            {items.map(function (t) { return (<react_native_1.TouchableOpacity style={styles_1.default.option} key={t.value} onPress={function () { return _this.onSelectOption(t); }}>
                  {showSelectedIndicator && selectedItem.value === t.value ? <react_native_1.View style={styles_1.default.selectedTabIndicator}/> : <react_native_1.View />}
                  <react_native_1.Text style={[styles_1.default.optionText, { fontWeight: selectedItem.value === t.value ? 'bold' : 'normal' }]}>{t.name}</react_native_1.Text>
                  <react_native_1.View />
                </react_native_1.TouchableOpacity>); })}
          </react_native_1.ScrollView>
        </react_native_1.Animated.View>

        {isMenuOpen ? <react_native_1.View style={styles_1.default.anchor}/> : null}

        <react_native_1.TouchableOpacity style={styles_1.default.trigger} onPress={this.toggleMenu}>
          <react_native_1.Text>Tabs</react_native_1.Text>
        </react_native_1.TouchableOpacity>
      </react_native_1.View>);
    };
    FloatingMenu.defaultProps = {
        showSelectedItemIndicator: true,
        closeMenuOnSelect: true,
    };
    return FloatingMenu;
}(React.Component));
exports.default = FloatingMenu;
